Page MenuHomePhabricator

Special:ContentTranslation gives "No such special page" if user hasn't enabled the beta feature
Closed, ResolvedPublic

Description

Special:ContentTranslation gives "No such special page" if user hasn't enabled the beta feature. It should instead produce an error saying that the user hasn't enabled the beta feature, and a link to preferences where it can be enabled.

Event Timeline

matmarex created this task.Jan 30 2016, 3:01 PM
matmarex raised the priority of this task from to Needs Triage.
matmarex updated the task description. (Show Details)
matmarex added a project: ContentTranslation.
matmarex added a subscriber: matmarex.
Restricted Application added subscribers: StudiesWorld, Aklapper. · View Herald TranscriptJan 30 2016, 3:01 PM
Amire80 triaged this task as Low priority.Jan 31 2016, 10:36 AM
Amire80 added a project: WorkType-Maintenance.
Amire80 set Security to None.
Amire80 moved this task from Needs Triage to CX9 candidates on the ContentTranslation board.
Amire80 added a subscriber: Jdforrester-WMF.
Amire80 added subscribers: Pginer-WMF, Eloquence, Amire80.

It's an easy thing to fix if there's a policy about how it should work.

It works as it does now because back in 2014 @Eloquence requested the beta feature to be completely invisible to people who didn't enable it, saying that all beta features should be like that. Reality is more complicated than that, however, and I'm open to change.

@matmarex's suggestion sounds sensible to me, but I'd love to hear the opinions of @Jdforrester-WMF and @Pginer-WMF.

I'd be OK with a page saying "This page is unavailable unless you opt-in to the Beta Feature" or something similar, but I'm not sure how much work it'd be.

I'm totally supporting this idea.

  • It would provide an easy link to share for people to try the tool in our communications. Currently we have to direct people to the "try the tool" section of the project page, where users have to follow instructions.
  • It would alleviate the issues of beta features affecting a single wiki. A user enabling the beta feature in Japanese may navigate to Korean Wikipedia and not find obvious why the page is not there.

I'd also recommend not to present it as an error (i.e., with the negative connotation that the user did something wrong), but as an invitation to enable the beta feature. If this is considered for upcoming sprints, I'll be happy to provide some designs about this.

Devirk added a subscriber: Devirk.Feb 1 2016, 1:35 PM
Devirk claimed this task.Feb 1 2016, 1:46 PM

@Jdforrester-WMF, @Pginer-WMF, thanks for the comments. We're more or less in sync then, and we'll add it to one of the upcoming sprints.

I'd be OK with a page saying "This page is unavailable unless you opt-in to the Beta Feature" or something similar, but I'm not sure how much work it'd be.

From a quick look, it's mostly going to be the work in writing the text. ContentTranslation seems to already check this by itself (what we're seeing now isn't the real error message indicating the special page doesn't exist, it's a fake one generated by ContentTranslation that mimics the real one very well). So very little programming, more copywriting. :)

This line in SpecialContentTranslation.php:

$out->showErrorPage( 'nosuchspecialpage', 'nospecialpagetext' );
Devirk removed Devirk as the assignee of this task.Feb 3 2016, 2:11 PM

Change 269403 had a related patch set uploaded (by Santhosh):
Provide one click beta feature activation from Special:CX

https://gerrit.wikimedia.org/r/269403

Change 269403 merged by jenkins-bot:
Provide one click beta feature activation from Special:CX

https://gerrit.wikimedia.org/r/269403

Change 269416 had a related patch set uploaded (by KartikMistry):
CX: Enable specialcx campaign

https://gerrit.wikimedia.org/r/269416

Amire80 assigned this task to santhosh.Feb 9 2016, 7:13 PM
Amire80 moved this task from Backlog to QA on the LE-CX8-Sprint 2 board.

Change 269416 merged by jenkins-bot:
CX: Enable specialcx campaign

https://gerrit.wikimedia.org/r/269416

santhosh moved this task from QA to Done on the LE-CX8-Sprint 2 board.Feb 11 2016, 11:49 AM

A couple of considerations:

  • For logged-out users we may want to point them to the log-in form with the appropriate "returnto" parameter. Otherwise, they have to make an additional manual step.
  • In the current version there are three links at a similar level of prominence. The option to enable the tool should be the first and most prominent option.
  • It would be good to mention that it is a beta tool to set expectations.

I represented the above ideas in a mockup below:

Amire80 closed this task as Resolved.Feb 14 2016, 11:27 AM

Verified in production.

A couple of considerations:

  • For logged-out users we may want to point them to the log-in form with the appropriate "returnto" parameter. Otherwise, they have to make an additional manual step.

As far as I tested, this already works in a sensible way. Clicking the "try" link takes the user to the log-in form and after typing the password correctly, the user is taken to Special:CX with the beta feature auto-enabled.

  • In the current version there are three links at a similar level of prominence. The option to enable the tool should be the first and most prominent option.
  • It would be good to mention that it is a beta tool to set expectations.

I represented the above ideas in a mockup below:

I created T126907 to track this suggestion. Thanks!

Verified in production.

A couple of considerations:

  • For logged-out users we may want to point them to the log-in form with the appropriate "returnto" parameter. Otherwise, they have to make an additional manual step.

As far as I tested, this already works in a sensible way. Clicking the "try" link takes the user to the log-in form and after typing the password correctly, the user is taken to Special:CX with the beta feature auto-enabled.

This is what I get after clicking the "try" link:

This is what I'd expect:

NOTE: As per our analytics, from Feb 11 to Feb 29, 75 users activated CX by this one click beta feature activation
Restricted Application added a subscriber: TerraCodes. · View Herald TranscriptAug 25 2016, 7:38 PM